/* +------------------------------------------------------------------------+
   |                                                                        |
   |                      Racine carre traditionnelle                      |
   |                                                                        |
   +------------------------------------------------------------------------+ */

#include "defs.h"

/* c <- 2*trunc(a^1/2), a <- a - c^2/4, lg(a) = 2n */
/* le chiffre de poids fort de a doit tre compris */
/* entre base/16 inclus et base/4 exclus           */

void sqrtn2(ndouble *c, ndouble *a, int n) {
  int i,j;
  ndouble q,r,x,y;
  zdouble z;

  /* racine carre des deux chiffres de tte */
  r = a[2*n-2] + (a[2*n-1] << shift);
  for (x=mask/2,y=x+1; x < y;) {y = x; x = (x + r/x)/2;}
  r -= y*y; a[2*n-2] = r & mask; a[2*n-1] = r >> shift;
  y <<= 1;  c[n-1] = y;

  /* calcule les chiffres suivants par division */
  for (i=n-2; i>=0; i--) {

    if (a[n+i+1]) q = mask;
    else {
      x = (a[i+n] << shift) + a[i+n-1];
      q = x/y;
      if (q > mask) q = mask;
    }
    c[i] = q;

    /* a <- a - c*q - q^2 */
    for (j=i,r=z=0; j <= n+1; j++) {
      if (j < n) r += q*c[j];
      z = a[i+j] - (r&mask);
      a[i+j] = z & mask;
      r >>= shift;
      if (z < 0) r++;
    }

    /* si ngatif corrige */
    while(z) {
      z += inc(a+2*i, c+i, n-i+2, n-i);
      q--; c[i] = q;
      z += inc(a+2*i, c+i, n-i+2, 1);
    }

    /* double le chiffre ajout */
    for (j=i,r=q; (r); j++) {
      r += c[j];
      c[j] = r & mask;
      r >>= shift;
    }
  }
}

